import com.ibm.mq.*; //Include the WebSphere MQ classes for Java package

public class MQDistList
{
    // define the name of the QueueManager
    private static final String qManager = "MQA1";
    // main method: simply call the runSample() meth
    public static void main(String args[])
    {
        new MQDistList().runSample();
    }

    public void runSample()
    {
        try
        {
            MQEnvironment.hostname="localhost";
            MQEnvironment.channel = "SYSTEM.DEF.SVRCONN";
            MQEnvironment.port = 1414;
            // Create a connection to the QueueManager
            System.out.println("Connecting to queue manager: "+qManager);
            MQQueueManager qMgr = new MQQueueManager(qManager);

            MQDistributionListItem[] dil = new MQDistributionListItem[2];
            MQDistributionListItem li1 = new MQDistributionListItem();
            li1.queueName = "TEST.1";
            dil[0] = li1;
            MQDistributionListItem li2 = new MQDistributionListItem();
            li2.queueName = "TEST.2";
            dil[1] = li2;

            // Set up the options on the queue we wish to open
            int openOptions = MQC.MQOO_OUTPUT;
            MQDistributionList dl = qMgr.accessDistributionList( dil, openOptions);

            // Define a simple WebSphere MQ Message ...
            MQMessage msg = new MQMessage();
            // ... and write some text in UTF8 format
            msg.writeString("Hello, World!");

            // Specify the default put message options
            MQPutMessageOptions pmo = new MQPutMessageOptions();

            // Put the message to the queue
            System.out.println("Sending a message...");
            dl.put(msg, pmo);

            MQDistributionList d2 = qMgr.accessDistributionList( dil , openOptions );
            System.out.println("Sending a message...");
            msg.writeString("and Hello, Mars!");
            d2.put(msg, pmo);

            // Disconnect from the QueueManager
            System.out.println("Disconnecting from the Queue Manager");
            qMgr.disconnect();
            System.out.println("Done!");
        }
        catch (MQException ex)
        {
            System.out.println("A WebSphere MQ Error occured : Completion Code "
                    + ex.completionCode + " Reason Code " + ex.reasonCode);
        }
        catch (java.io.IOException ex)
        {
            System.out.println("An IOException occured whilst writing to the message buffer: "
                    + ex);
        }
    }
}

